#include "const_test.hpp"

void
T1::dispatch_m(BaseConst *BaseConst_o)
{
  BaseConst_o->m(this);
}

void
T1::dispatch_m_const(BaseConst *BaseConst_o)
{
  BaseConst_o->m((const T1 *)(this));
}

void
T1::dispatch_m(DerivConst *DerivConst_o)
{
  DerivConst_o->m(this);
}

void
T1::dispatch_m_const(DerivConst *DerivConst_o)
{
  DerivConst_o->m((const T1 *)(this));
}

void
T2::dispatch_m(BaseConst *BaseConst_o)
{
  BaseConst_o->m(this);
}

void
T2::dispatch_m_const(BaseConst *BaseConst_o)
{
  BaseConst_o->m((const T2 *)(this));
}

void
T2::dispatch_m(DerivConst *DerivConst_o)
{
  DerivConst_o->m(this);
}

void
T2::dispatch_m_const(DerivConst *DerivConst_o)
{
  DerivConst_o->m((const T2 *)(this));
}

void
T3::dispatch_m(DerivConst *DerivConst_o)
{
  DerivConst_o->m(this);
}

void
T3::dispatch_m_const(DerivConst *DerivConst_o)
{
  DerivConst_o->m((const T3 *)(this));
}

void
#line 20 "const_test.h"
BaseConst::m(T1 * t)
#line 20 "const_test.h"
{ cout << "BaseConst::m(T1)" << endl; }

void
#line 21 "const_test.h"
BaseConst::m(T2 * t)
#line 21 "const_test.h"
{ cout << "BaseConst::m(T2)" << endl; }

void
#line 22 "const_test.h"
BaseConst::m(const T1 * t)
#line 22 "const_test.h"
{ cout << "BaseConst::m(const T1)" << endl; }

void
#line 23 "const_test.h"
BaseConst::m(const T2 * t)
#line 23 "const_test.h"
{ cout << "BaseConst::m(const T2)" << endl; }

void
BaseConst::m_DB(T1 * t)
{
  t->dispatch_m(this);
}

void
BaseConst::m_DB(const T1 * t)
{
  (const_cast<T1 *>(t))->dispatch_m_const(this);
}

void
#line 33 "const_test.h"
DerivConst::m(T2 * t)
#line 33 "const_test.h"
{ cout << "DerivConst::m(T2)" << endl; }

void
#line 34 "const_test.h"
DerivConst::m(T3 * t)
#line 34 "const_test.h"
{ cout << "DerivConst::m(T3)" << endl; }

void
#line 35 "const_test.h"
DerivConst::m(const T2 * t)
#line 35 "const_test.h"
{ cout << "DerivConst::m(const T2)" << endl; }

void
#line 36 "const_test.h"
DerivConst::m(const T3 * t)
#line 36 "const_test.h"
{ cout << "DerivConst::m(const T3)" << endl; }

void
DerivConst::m_DB(T1 * t)
{
  t->dispatch_m(this);
}

void
DerivConst::m_DB(const T1 * t)
{
  (const_cast<T1 *>(t))->dispatch_m_const(this);
}

