// a subclass introduces a branch with a supertype w.r.t. the superclass
// however, in the superclass the method is private

#ifndef CONTRA_SPEC_H
#define CONTRA_SPEC_H

#include <iostream>

using std::cout;
using std::endl;

// doublecpp: forward declarations, DO NOT MODIFY
class Contra_Spec; // file: contra_spec_private.h
// doublecpp: end, DO NOT MODIFY

#line 12 "contra_spec_private.h"
class T1
{ 
 public:
  virtual ~T1() {}

  virtual void foo() {} 
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Contra_Spec *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class Contra_Base; // file: contra_spec_private.h
// doublecpp: end, DO NOT MODIFY

#line 20 "contra_spec_private.h"
class T2 : public T1
{// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Contra_Base *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class Contra_Base; // file: contra_spec_private.h
// doublecpp: end, DO NOT MODIFY

#line 22 "contra_spec_private.h"
class T3 : public T2
{// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Contra_Base *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class T2; // file: contra_spec_private.h
class T3; // file: contra_spec_private.h
// doublecpp: end, DO NOT MODIFY

#line 24 "contra_spec_private.h"
class Contra_Base
{
// doublecpp: method branches, DO NOT MODIFY
#line 27 "contra_spec_private.h"
void m(T2 * t);
#line 28 "contra_spec_private.h"
void m(T3 * t);
public:
void _forward_m(T2 * t)
{
  m(t);
};

void _forward_m(T3 * t)
{
  m(t);
};

private:
void m_DB(T2 * t);
#line 28 "contra_spec_private.h"
// doublecpp: end, DO NOT MODIFY


public:
  void my_pub(T2 *t)
  {
    m_DB(t);
  }
};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: contra_spec_private.h
// doublecpp: end, DO NOT MODIFY

#line 38 "contra_spec_private.h"
class Contra_Spec : public Contra_Base
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 42 "contra_spec_private.h"
void m(T1 * t);
void m_DB(T1 * t);
#line 42 "contra_spec_private.h"
// doublecpp: end, DO NOT MODIFY

};

#endif // CONTRA_SPEC_H
