// a subclass introduces a branch with a supertype w.r.t. the superclass
// however, in the superclass the method is private

#ifndef CONTRA_SPEC_H
#define CONTRA_SPEC_H

#include <iostream>

using std::cout;
using std::endl;

#line 12 "contra_spec_private.hhh"
class T1
{ 
 public:
  virtual void foo() {} 

  virtual ~T1() {}
};

#line 20 "contra_spec_private.hhh"
class T2 : public T1
{};

#line 22 "contra_spec_private.hhh"
class T3 : public T2
{};

// doublecpp: forward declarations, DO NOT MODIFY
class T2; // file: contra_spec_private.hhh
class T3; // file: contra_spec_private.hhh
// doublecpp: end, DO NOT MODIFY

#line 24 "contra_spec_private.hhh"
class Contra_Base
{
// doublecpp: method branches, DO NOT MODIFY
#line 27 "contra_spec_private.hhh"
void m(T2 * t);
#line 28 "contra_spec_private.hhh"
void m(T3 * t);
void m_DB(T2 * t);
#line 28 "contra_spec_private.hhh"
// doublecpp: end, DO NOT MODIFY


public:
  void my_pub(T2 *t)
  {
    m_DB(t);
  }

  virtual ~Contra_Base() {}
};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: contra_spec_private.hhh
// doublecpp: end, DO NOT MODIFY

#line 40 "contra_spec_private.hhh"
class Contra_Spec : public Contra_Base
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 44 "contra_spec_private.hhh"
void m(T1 * t);
void m_DB(T1 * t);
#line 44 "contra_spec_private.hhh"
// doublecpp: end, DO NOT MODIFY

};

#endif // CONTRA_SPEC_H
