/*
  a derived from two bases, specializing the same method
 */

#ifndef DMULSAME_H
#define DMULSAME_H

#include <iostream>

using std::cout;
using std::endl;

class TSame1
{
 public:
  virtual void foo1() { cout << "TSame1::foo1"; }

  virtual ~TSame1() {}
};

class TSame2 : public TSame1
{
 public:
  void foo1() { cout << "TSame2::foo1"; }
};

class BSame1
{
 public:
  virtual branch m
    virtual void (TSame1 *t)
    { cout << "BSame1::m(TSame1)" << endl; };
  endbranch

  virtual branch foo
    virtual void (TSame1 *t)
    { cout << "BSame1::foo(TSame1)" << endl; };
  endbranch

  virtual ~BSame1() {}
};

class BSame2
{
 public:
  virtual branch m
    virtual void (TSame1 *t)
    { cout << "BSame2::m(TSame1)" << endl; };
  endbranch

  virtual branch foo
    virtual void (TSame1 *t)
    { cout << "BSame2::foo(TSame1)" << endl; };
  endbranch

  virtual ~BSame2() {}
};

class DSame : public BSame1, public BSame2
{
 public:
  // notice that the version of m for TSame1 has to be made
  // non ambigous
  virtual branch m
    virtual void (TSame1 *t)
    { 
      cout << "DSame::m(TSame1)" << endl;
      cout << "  "; BSame1::m_ (t);
      cout << "  "; BSame2::m_ (t);
    };
    virtual void (TSame2 *t)
    { 
      cout << "DSame::m(TSame2)" << endl; 
      cout << "  "; BSame1::m_ (t);
      cout << "  "; BSame2::m_ (t);
      cout << "  "; BSame1::foo_ (t);
    };
  endbranch

  virtual branch foo
    virtual void (TSame1 *t)
    { cout << "DSame::foo(TSame1)" << endl; };
  endbranch
};

#endif
