/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

/*
  It is basically the same of deriv2.h, but in this case a class in the
  middle, Deriv1 defines the multi method as protected, so Deriv2 receives
  only the branches defined in Base1
 */

#ifndef DERIV2_PROTECTED_H
#define DERIV2_PROTECTED_H

#include <iostream>

class T1
{
 public:
  virtual ~T1() {}

  virtual void foo() {}
};

class T1_d : public T1
{
  void foo() {}
};

class T2 : public T1_d
{
  void foo2() {}
};

class T3 : public T2
{
  void foo3() {}
};

class T4 : public T3
{
  void foo4() {}
};

class Base1
{
 public:
  virtual branch m
  virtual void (T1 *t) { std::cout << "Base1::m(T1)" << std::endl; };
  virtual void (T2 *t) { 
    // comment line
    std::cout << "Base1::m(T2)" << std::endl;
  };
  endbranch

  virtual branch n
  virtual void (T1 *t) { std::cout << "Base1::n(T1)" << std::endl; };
  virtual void (T2 *t) { 
    // comment line
    std::cout << "Base1::n(T2)" << std::endl;
  };

  virtual void (T1 *t, int i) { std::cout << "Base1::n(T1,i)" << std::endl; };
  virtual void (T2 *t, int i) { 
    // comment line
    std::cout << "Base1::n(T2,i)" << std::endl;
  };
  endbranch

  virtual ~Base1() {}
};

class D : public Base1
{

};

class Deriv1 : public D
{
 protected:
  // notice that in this class the method is protected
  branch m
  void (T1 *tt);
  void (T3 *t);
  endbranch

  branch n
  void (T1 *tt) { std::cout << "Deriv1::n(T1)" << std::endl; };
  void (T3 *t, int i) { std::cout << "Deriv1::n(T3,i)" << std::endl; };
  endbranch
};

class D1 : public Deriv1
{

};

class Deriv2 : public D1
{
 public:
  branches m
  void (T4 *t) { std::cout << "Deriv2::m(T4)" << std::endl; };
  endbranches

  branch n
  void (T4 *t, int i) { std::cout << "Deriv2::n(T4,i)" << std::endl; };
  endbranch
} ;

class Deriv1_b : public D
{
  // notice that in this class the method is protected
 protected:
  branch m
    void (T3 *t) { std::cout << "Deriv2_b::m(T3)" << std::endl; };
  endbranch
};

class Deriv2_b : public Deriv1_b
{
 public:
  branches m
  void (T4 *t) { std::cout << "Deriv2_b::m(T4)" << std::endl; };
  endbranches
} ;

#endif
