// multiple inheritance concerns both for target types and for clients

#ifndef DMUL_TARGET_CLIENT_H
#define DMUL_TARGET_CLIENT_H

#include <iostream>

using std::cout;
using std::endl;

class T1
{
 public:
  virtual void foo() {}

  virtual ~T1() {}
};

class T2
{
 public:
  virtual void bar() {}

  virtual ~T2() {}
};

class T3 : public T1, public T2
{

};

class S1 {
 public:
  virtual void S_foo() {}

  virtual ~S1() {}
};

class S2 : public S1 {};

class V1 {
 public:
  virtual void V_foo() {}

  virtual ~V1() {}
};

class V2 : public V1 {};

class SV : public S2, public V2 {};

class TT : public T3 {};

class SV2 : public SV {};

class TTSV : public TT, public SV2 {};

class C1
{
 public:
  virtual ~C1() {}

  virtual branch m
    virtual void (T1 *t) { cout << "C1::m(T1)" << endl; };
  endbranch
};

class C2 
{
 public:
  virtual ~C2() {}
  virtual branch m
    virtual void (T2 *t) { cout << "C2::m(T2)" << endl; };
  endbranch
};

class C3 : public C1, public C2
{
 public:
  virtual branch m
    virtual void (T3 *t) { cout << "C3::m(T3)" << endl; };
  endbranch
};

class Multi
{
  branches m
    void (T1 *) { cout << "Multi::m(T1)" << endl; };
    void (T2 *) { cout << "Multi::m(T2)" << endl; };
    void (T3 *) { cout << "Multi::m(T3)" << endl; };
    void (S1 *) { cout << "Multi::m(S1)" << endl; };
    void (V1 *) { cout << "Multi::m(V1)" << endl; };
    void (SV *) { cout << "Multi::m(SV)" << endl; };
    void (TTSV *) { cout << "Multi::m(TTSV)" << endl; };
  endbranches

 public:
    void my_test() {
      m_DB(new T1);
      m_DB(new T2);
      m_DB(new T3);
      m_DB(new S1);
      m_DB(new V1);
      m_DB(new SV);
      m_DB(new TTSV);
    }

  virtual ~Multi() {}
};

#endif // DMUL_TARGET_CLIENT_H
