// multiple inheritance concerns both for target types and for clients

#ifndef DMUL_TARGET_CLIENT_H
#define DMUL_TARGET_CLIENT_H

#include <iostream>

using std::cout;
using std::endl;

// doublecpp: forward declarations, DO NOT MODIFY
class C1; // file: dmul_target_client.h
class C3; // file: dmul_target_client.h
class Multi; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 11 "dmul_target_client.h"
class T1
{
 public:
  virtual void foo() {}

  virtual ~T1() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(C1 *);
virtual void dispatch_m(C3 *);
virtual void dispatch_m(Multi *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class C2; // file: dmul_target_client.h
class C3; // file: dmul_target_client.h
class Multi; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 19 "dmul_target_client.h"
class T2
{
 public:
  virtual void bar() {}

  virtual ~T2() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(C2 *);
virtual void dispatch_m(C3 *);
virtual void dispatch_m(Multi *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class C3; // file: dmul_target_client.h
class Multi; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 27 "dmul_target_client.h"
class T3 : public T1, public T2
{

// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(C3 *);
virtual void dispatch_m(Multi *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class Multi; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 32 "dmul_target_client.h"
class S1
{
 public:
  virtual void S_foo() {}

  virtual ~S1() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Multi *);
// doublecpp: end, DO NOT MODIFY
};

#line 39 "dmul_target_client.h"
class S2 : public S1
{};

// doublecpp: forward declarations, DO NOT MODIFY
class Multi; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 41 "dmul_target_client.h"
class V1
{
 public:
  virtual void V_foo() {}

  virtual ~V1() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Multi *);
// doublecpp: end, DO NOT MODIFY
};

#line 48 "dmul_target_client.h"
class V2 : public V1
{};

// doublecpp: forward declarations, DO NOT MODIFY
class Multi; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 50 "dmul_target_client.h"
class SV : public S2, public V2
{// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Multi *);
// doublecpp: end, DO NOT MODIFY
};

#line 52 "dmul_target_client.h"
class TT : public T3
{};

#line 54 "dmul_target_client.h"
class SV2 : public SV
{};

// doublecpp: forward declarations, DO NOT MODIFY
class Multi; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 56 "dmul_target_client.h"
class TTSV : public TT, public SV2
{// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Multi *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 58 "dmul_target_client.h"
class C1
{
 public:
  virtual ~C1() {}

// doublecpp: method branches, DO NOT MODIFY
#line 64 "dmul_target_client.h"
virtual void m(T1 * t);
virtual void m_DB(T1 * t);
#line 64 "dmul_target_client.h"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T2; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 68 "dmul_target_client.h"
class C2
{
 public:
  virtual ~C2() {}
// doublecpp: method branches, DO NOT MODIFY
#line 73 "dmul_target_client.h"
virtual void m(T2 * t);
virtual void m_DB(T2 * t);
#line 73 "dmul_target_client.h"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T3; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 77 "dmul_target_client.h"
class C3 : public C1, public C2
{
 public:
// doublecpp: method branches, DO NOT MODIFY
using C1::m;
using C2::m;
#line 81 "dmul_target_client.h"
virtual void m(T3 * t);
virtual void m_DB(T1 * t);
virtual void m_DB(T2 * t);
virtual void m_DB(T3 * t);
#line 81 "dmul_target_client.h"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class S1; // file: dmul_target_client.h
class SV; // file: dmul_target_client.h
class T1; // file: dmul_target_client.h
class T2; // file: dmul_target_client.h
class T3; // file: dmul_target_client.h
class TTSV; // file: dmul_target_client.h
class V1; // file: dmul_target_client.h
// doublecpp: end, DO NOT MODIFY

#line 85 "dmul_target_client.h"
class Multi
{
// doublecpp: method branches, DO NOT MODIFY
#line 88 "dmul_target_client.h"
void m(T1 * _param1);
#line 89 "dmul_target_client.h"
void m(T2 * _param1);
#line 90 "dmul_target_client.h"
void m(T3 * _param1);
#line 91 "dmul_target_client.h"
void m(S1 * _param1);
#line 92 "dmul_target_client.h"
void m(V1 * _param1);
#line 93 "dmul_target_client.h"
void m(SV * _param1);
#line 94 "dmul_target_client.h"
void m(TTSV * _param1);
public:
void _forward_m(S1 * _param1)
{
  m(_param1);
};

void _forward_m(SV * _param1)
{
  m(_param1);
};

void _forward_m(T1 * _param1)
{
  m(_param1);
};

void _forward_m(T2 * _param1)
{
  m(_param1);
};

void _forward_m(T3 * _param1)
{
  m(_param1);
};

void _forward_m(TTSV * _param1)
{
  m(_param1);
};

void _forward_m(V1 * _param1)
{
  m(_param1);
};

private:
void m_DB(S1 * _param1);
void m_DB(SV * _param1);
void m_DB(T1 * _param1);
void m_DB(T2 * _param1);
void m_DB(T3 * _param1);
void m_DB(TTSV * _param1);
void m_DB(V1 * _param1);
#line 94 "dmul_target_client.h"
// doublecpp: end, DO NOT MODIFY


 public:
    void my_test() {
      m_DB(new T1);
      m_DB(new T2);
      m_DB(new T3);
      m_DB(new S1);
      m_DB(new V1);
      m_DB(new SV);
      m_DB(new TTSV);
    }

  virtual ~Multi() {}
};

#endif // DMUL_TARGET_CLIENT_H
