// multiple inheritance concerns both for target types and for clients

#ifndef DMUL_TARGET_CLIENT_H
#define DMUL_TARGET_CLIENT_H

#include <iostream>

using std::cout;
using std::endl;

#line 11 "dmul_target_client.hhh"
class T1
{
 public:
  virtual void foo() {}

  virtual ~T1() {}
};

#line 19 "dmul_target_client.hhh"
class T2
{
 public:
  virtual void bar() {}

  virtual ~T2() {}
};

#line 27 "dmul_target_client.hhh"
class T3 : public T1, public T2
{

};

#line 32 "dmul_target_client.hhh"
class S1
{
 public:
  virtual void S_foo() {}

  virtual ~S1() {}
};

#line 39 "dmul_target_client.hhh"
class S2 : public S1
{};

#line 41 "dmul_target_client.hhh"
class V1
{
 public:
  virtual void V_foo() {}

  virtual ~V1() {}
};

#line 48 "dmul_target_client.hhh"
class V2 : public V1
{};

#line 50 "dmul_target_client.hhh"
class SV : public S2, public V2
{};

#line 52 "dmul_target_client.hhh"
class TT : public T3
{};

#line 54 "dmul_target_client.hhh"
class SV2 : public SV
{};

#line 56 "dmul_target_client.hhh"
class TTSV : public TT, public SV2
{};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: dmul_target_client.hhh
// doublecpp: end, DO NOT MODIFY

#line 58 "dmul_target_client.hhh"
class C1
{
 public:
  virtual ~C1() {}

// doublecpp: method branches, DO NOT MODIFY
#line 64 "dmul_target_client.hhh"
virtual void m(T1 * t);
virtual void m_DB(T1 * t);
#line 64 "dmul_target_client.hhh"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T2; // file: dmul_target_client.hhh
// doublecpp: end, DO NOT MODIFY

#line 68 "dmul_target_client.hhh"
class C2
{
 public:
  virtual ~C2() {}

// doublecpp: method branches, DO NOT MODIFY
#line 74 "dmul_target_client.hhh"
virtual void m(T2 * t);
virtual void m_DB(T2 * t);
#line 74 "dmul_target_client.hhh"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T3; // file: dmul_target_client.hhh
// doublecpp: end, DO NOT MODIFY

#line 78 "dmul_target_client.hhh"
class C3 : public C1, public C2
{
 public:
// doublecpp: method branches, DO NOT MODIFY
using C1::m;
using C2::m;
#line 82 "dmul_target_client.hhh"
virtual void m(T3 * t);
virtual void m_DB(T1 * t);
virtual void m_DB(T2 * t);
virtual void m_DB(T3 * t);
#line 82 "dmul_target_client.hhh"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class S1; // file: dmul_target_client.hhh
class SV; // file: dmul_target_client.hhh
class T1; // file: dmul_target_client.hhh
class T2; // file: dmul_target_client.hhh
class T3; // file: dmul_target_client.hhh
class TTSV; // file: dmul_target_client.hhh
class V1; // file: dmul_target_client.hhh
// doublecpp: end, DO NOT MODIFY

#line 86 "dmul_target_client.hhh"
class Multi
{
// doublecpp: method branches, DO NOT MODIFY
#line 89 "dmul_target_client.hhh"
void m(T1 * _param1);
#line 90 "dmul_target_client.hhh"
void m(T2 * _param1);
#line 91 "dmul_target_client.hhh"
void m(T3 * _param1);
#line 92 "dmul_target_client.hhh"
void m(S1 * _param1);
#line 93 "dmul_target_client.hhh"
void m(V1 * _param1);
#line 94 "dmul_target_client.hhh"
void m(SV * _param1);
#line 95 "dmul_target_client.hhh"
void m(TTSV * _param1);
void m_DB(S1 * _param1);
void m_DB(SV * _param1);
void m_DB(T1 * _param1);
void m_DB(T2 * _param1);
void m_DB(T3 * _param1);
void m_DB(TTSV * _param1);
void m_DB(V1 * _param1);
#line 95 "dmul_target_client.hhh"
// doublecpp: end, DO NOT MODIFY


 public:
    void my_test() {
      m_DB(new T1);
      m_DB(new T2);
      m_DB(new T3);
      m_DB(new S1);
      m_DB(new V1);
      m_DB(new SV);
      m_DB(new TTSV);
    }

  virtual ~Multi() {}
};

#endif // DMUL_TARGET_CLIENT_H
