// multiple inheritance concerns target types

#ifndef DMUL_TARGET_H
#define DMUL_TARGET_H

#include <iostream>

using std::cout;
using std::endl;

#line 11 "dmul_target.hhh"
class T1
{
 public:
  virtual void foo() {}

  virtual ~T1() {}
};

#line 19 "dmul_target.hhh"
class T2
{
 public:
  virtual void bar() {}

  virtual ~T2() {}
};

#line 27 "dmul_target.hhh"
class T3 : public T1, public T2
{

};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: dmul_target.hhh
// doublecpp: end, DO NOT MODIFY

#line 32 "dmul_target.hhh"
class C1
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 36 "dmul_target.hhh"
virtual void m(T1 * t);
virtual void m_DB(T1 * t);
#line 36 "dmul_target.hhh"
// doublecpp: end, DO NOT MODIFY


  virtual ~C1() {}
};

// doublecpp: forward declarations, DO NOT MODIFY
class T2; // file: dmul_target.hhh
// doublecpp: end, DO NOT MODIFY

#line 42 "dmul_target.hhh"
class C2 : public C1
{
 public:
// doublecpp: method branches, DO NOT MODIFY
using C1::m;
#line 46 "dmul_target.hhh"
virtual void m(T2 * t);
virtual void m_DB(T1 * t);
virtual void m_DB(T2 * t);
#line 46 "dmul_target.hhh"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T3; // file: dmul_target.hhh
// doublecpp: end, DO NOT MODIFY

#line 50 "dmul_target.hhh"
class C3 : public C2
{
 public:
// doublecpp: method branches, DO NOT MODIFY
using C2::m;
#line 54 "dmul_target.hhh"
virtual void m(T3 * t);
virtual void m_DB(T1 * t);
virtual void m_DB(T2 * t);
virtual void m_DB(T3 * t);
#line 54 "dmul_target.hhh"
// doublecpp: end, DO NOT MODIFY

};

#endif // DMUL_TARGET_H
